// ##############################
// Implementierung der Klasse Key
// ##############################

#include "Key.h"
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>

//Erzeugt ein neues Schlsselpaar und speichert die Schlssel 
// auf der Festplatte
int Key::Generieren(Primzahlen *prim)
{
	//Zufallszahlengenerator initialisieren
	srand((unsigned)time(NULL));

	//2. Schlssel anlegen
	Key KomplementaerKey;

	//Variablendeklaration
	char Puffer[255];
	int  count=0;

	printf("\n\n\n\nGenerierung eines neuen Schlsselpaars:\n");
	printf("1. Schritt: Finden von zwei zuflligen Primzahlen\n");

	//berprfung, ob Primzahlen vorhanden sind
	if (prim->Zahlen.Count==0)
	{
		printf("\nZuerst muessen Primzahlen geladen werden!\n");
		printf("(Weiter mit Taste)");
		getchar();getchar();
		return -1;
	}

	//P aus Zufallsprimzahl bestimmen
	VeryLong p;
	p=GetZufallsPrimzahl(prim);
	p.GetString(Puffer);
	printf("\tp:    %s\n",Puffer);

	//Q aus Zufallsprimzahl bestimmen
	VeryLong q;
	q=GetZufallsPrimzahl(prim);
	q.GetString(Puffer);
	printf("\tq:    %s\n",Puffer);

	//N aus P und Q errechnen
	VeryLong n;
	n=p*q;
	n.GetString(Puffer);
	printf("\tn:    %s\n",Puffer);

	printf("2. Schritt: Bilden von Phi, oeffentlichem und ");
	printf("geheimen Teil\n");

	//Phi aus P und Q bestimmen
	VeryLong phi;
	phi=(p-1)*(q-1);
	phi.GetString(Puffer);
	printf("\tPhi:  %s\n",Puffer);

	VeryLong d;
	VeryLong e;
	bool OK=false;

	//So lange versuchen, D und E zu bestimmen, bis das Ergebnis OK ist
	while (!OK)
	{
		//Zum berechnen wird ein zuflliger Wert X bentigt
		// um die Zahlengren ein bisschen einzuschrnken hier (2<X<20)
		d=1;
		e=1;
		printf("\tBilden eines zufaelligen x, so dass Phi2=Phi*x+1:\n");
		int x=rand()%19+2;
		printf("\tx:    %d\n",x);

		//Phi2 als Faktorprodukt von D und E festlegen
		VeryLong phi2;
		phi2=phi*x+1;
		phi2.GetString(Puffer);
		printf("\tPhi2: %s\n",Puffer);

		printf("\tZerlegen von Phi2 in die Primfaktoren:\n\t");

		//Dann Phi2 in die Primfaktoren zerlegen, um D und E zu bestimmen
		// Die Teiler kommen aus der Liste von Primzahlen
		VeryLong Teiler;
		Teiler=prim->Zahlen.GetFirst();
		int Counter=0;

		//So lange Phi2 noch nciht in alle Primfaktoren zerlegt ist...
		while (phi2>1)
		{
			//So lange Phi2 noch durch den aktuellen Teiler geteilt
			// werden kann...
			while ((phi2%Teiler)==0)
			{
				//Phi2 um den Teiler verkleinern
				phi2=phi2/Teiler;
				Teiler.GetString(Puffer);
				printf("%s, ",Puffer);

				//Jeden zweiten Primfaktor auf D und E aufteilen, 
				// damit beide grer werden
				if (Counter++%2==0)
					d=d*Teiler;
				else
					e=e*Teiler;
			}
			
			//Nchsten Teiler holen
			Teiler=prim->Zahlen.GetNext();

			//Wenn kein Teiler mehr da ist, abbrechen und neu versuchen...
			if (Teiler==0)
			{
				printf("\n\tProblem: Alle verfgbaren Primzahlen als ");
				printf("Teiler durchprobiert.\n");
				break;
			}
		}

		//Wenn Phi2 komplett zerlegt wurde und mehr als einen Teiler hat, 
		// kann abgebrochen werden
		if (phi2==1 && e!=1)
		{
			printf("OK!\n");
			OK=true;
		}
		else
		{
			if (e==1)
			{
				printf("\tProblem: mit x=%d ist Phi2 eine Primzahl, ",x);
				printf("nochmal versuchen...\n\n");
			}
		}

		//Testen, ob fr dieses Primzahlenpaar kein d und e 
		// gefunden werden kann
		if (count>30 && !OK)
		{
			printf("Mit diesen Primzaheln kann leider kein Schlssel ");
			printf("generiert werden.\n");
			printf("Bitte Nochmal starten\n");
			printf("(Weiter mit Taste)");
			getchar();getchar();
			return -1;
		}
		count++;
	}
	printf("\tDamit ergeben sich, wenn man die Teiler von Phi2\n");
	printf("\tgleichmaessig verteilt:\n");
	d.GetString(Puffer);
	printf("\td:    %s\n",Puffer);
	e.GetString(Puffer);
	printf("\te:    %s\n",Puffer);

	//Die ermittelten Werte in die Schlssel setzen
	printf("3. Schritt: Bilden oeffentlicher und geheimer Schlssel\n");
	getchar();
	printf("\tName des Schlssels: ");
	gets(Name);
	KomplementaerKey.Exponent=d;
	KomplementaerKey.Modulowert=n;
	KomplementaerKey.IstPrivate=true;
	strcpy(KomplementaerKey.Name,Name);
	//Privaten Schlssel speichern
	KomplementaerKey.Schreiben();

	Exponent=e;
	Modulowert=n;
	IstPrivate=false;
	//ffentlichen Schlssel speichern
	Schreiben();

	printf("Die beiden Schluessel wurden gespeichert!\n");
	printf("(Weiter mit Taste)");
	getchar();
	return 0;
}

//Zum lesen eines Schlssels von der Festplatte
int Key::Lesen()
{
	char Dateiname[255];
	char Puffer[255];

	//Dateinamen abfragen
	printf("\n\n\n\nBitte Dateinamen des Schluessels eingeben: ");
	scanf("%s",Dateiname);

	//Datei ffnen
	FILE *Datei;
	Datei=fopen(Dateiname,"r");
	if (Datei==NULL)
	{
		printf("Die Datei \"%s\" konnte nicht geoeffnet werden!\n",Dateiname);
		printf("(Weiter mit Taste)");
		getchar();getchar();
		return -1;
	}
	
	//Daten einlesen

	//Kopfzeile ignorieren
	fgets(Puffer,sizeof(Puffer),Datei);

	//Name des Schlssels
	fgets(Puffer,sizeof(Puffer),Datei);
	strcpy(Name,&Puffer[6]);
	Name[strlen(Name)-1]='\0';

	//ffentlicher oder Privater Schlssel?
	fgets(Puffer,sizeof(Puffer),Datei);
	if (strcmp(&Puffer[6],"Private\n")==0)
		IstPrivate=true;
	else
		IstPrivate=false;

	//Exponent einlesen
	fgets(Puffer,sizeof(Puffer),Datei);
	Puffer[strlen(Puffer)-1]='\0';
	Exponent.SetString(&Puffer[10]);

	//Modulowert einlesen
	fgets(Puffer,sizeof(Puffer),Datei);
	Puffer[strlen(Puffer)-1]='\0';
	Modulowert.SetString(&Puffer[12]);

	fclose(Datei);
	printf("OK. Schluessel aus Datei %s gelesen.\n",Dateiname);
	printf("(Weiter mit Taste)");
	getchar();getchar();
	return 0;
}

//Funktion zum Schreiben des Schlssels auf die Festplatte
void Key::Schreiben()
{
	char Dateiname[255];
	char Puffer[255];

	//Dateinamen aus Schlsselnamen generieren
	strcpy(Dateiname,Name);

	//Sonderzeichen aus Dateinamen entfernen
	int NameLen=strlen(Name);
	for (int i=0;i<NameLen;i++)
	{
		if (Dateiname[i]==' ')  Dateiname[i]='_';
		if (Dateiname[i]=='/')  Dateiname[i]='-';
		if (Dateiname[i]=='\\') Dateiname[i]='-';
		if (Dateiname[i]==':')  Dateiname[i]='-';
		if (Dateiname[i]=='?')  Dateiname[i]='-';
		if (Dateiname[i]=='*')  Dateiname[i]='-';
		if (Dateiname[i]=='<')  Dateiname[i]='-';
		if (Dateiname[i]=='>')  Dateiname[i]='-';
		if (Dateiname[i]=='|')  Dateiname[i]='-';
		if (Dateiname[i]=='\"') Dateiname[i]='-';
	}
	//...und Suffix anfgen
	if  (IstPrivate)
		strcat(Dateiname,"_PrivateKey.txt");
	else
		strcat(Dateiname,"_PublicKey.txt");

	//Datei ffnen
	FILE *Datei;
	Datei=fopen(Dateiname,"w");
	if (Datei==NULL)
	{
		printf("Die Datei \"%s\" konnte nicht geschrieben werden!\n",Dateiname);
		printf("(Weiter mit Taste)");
		getchar();getchar();
	}
	
	//Kopf schreiben
	fprintf(Datei,"---SimpleRSA Key---\n");
	//Schlsselnamen schreiben
	fprintf(Datei,"Name: %s\n",Name);
	//Schlsseltyp schreiben
	if (IstPrivate)
		fprintf(Datei,"Type: Private\n");
	else
		fprintf(Datei,"Type: Public\n");
	//Exponenten schreiben
	Exponent.GetString(Puffer);
	fprintf(Datei,"Exponent: %s\n",Puffer);
	//Modulowert schreiben
	Modulowert.GetString(Puffer);
	fprintf(Datei,"Modulowert: %s\n",Puffer);
	//Fu schreiben
	fprintf(Datei,"---SimpleRSA Ende---\n");

	fclose(Datei);
	printf("OK. Schluessel in Datei %s geschrieben.\n",Dateiname);
	printf("(Weiter mit Taste)");
}

//Funktion zum ermiteln der Blocklnge zum Verschlsseln
int Key::GetBlockSize()
{
	return Modulowert.Len()-1;
}

//Hilfsfunktion zum finden einer zuflligen Primzahl aus der Primzahlenliste
VeryLong Key::GetZufallsPrimzahl(Primzahlen *prim)
{
	//Variablendeklarationen
	int Pos;
	VeryLong ZufallsPrimzahl;

	//Position in der Liste festlegen
	// Zwei Zufallszahlen zusammenbringen, sonst sind nur werte von 0-32767 mglich...
	Pos=(rand()<<16)+rand();
	
	//Zufallsposition auf Liste anpassen
	Pos=(Pos%(int)(prim->Zahlen.Count));

	//Die Liste bis zur gewnschten Position ablaufen
	ZufallsPrimzahl=prim->Zahlen.GetFirst();
	for (int i=0;i<Pos;i++)
		ZufallsPrimzahl=prim->Zahlen.GetNext();

	return ZufallsPrimzahl;
}

//Konstruktor
Key::Key()
{
	Exponent=0;
	IstPrivate=false;
	Modulowert=0;
	Name[0]='\0';
}

//Destruktor
Key::~Key()
{
}
