// ###################################
// Implementierung der Klasse VeryLong
// ###################################

#include "VeryLong.h"
#include <string.h>
#include <stdio.h>

//berlagerter Plus-Operator zur Adition zweier Zahlen des Typs VeryLong
VeryLong VeryLong::operator + (VeryLong Wert2)
{
	//Variablendeklaration
	VeryLong ergebnis;
	int temp;
	int uebertrag=0;

	//Einzelne Stellen addieren
	//(Die beiden Zahlen werden addiert und der bertrag der letzten
	// Stelle dazugenommen. Ein bertrag wird fr die nchste Stelle
	// gespeichert. Ist die Zahl zu lang, geht dies verloren!)
	for (int i=0;i<VeryLongSize;i++)
	{
		temp=Zahl[i]+Wert2.Zahl[i]+uebertrag;
		ergebnis.Zahl[i]=(unsigned char)(temp%256);
		uebertrag=temp/256;
	}

	return ergebnis;
}

//berlagerter Plus-Operator zur Adition einer INT Zahl zum Typ VeryLong
VeryLong VeryLong::operator + (int Wert2)
{
	//Variablendeklaration
	VeryLong ergebnis;
	int temp;
	int uebertrag=0;

	//Einzelne Stellen addieren
	//(Es wird die komplette VeryLong-Zahl abgelaufen, damit ein
	// eventueller bertrag weitergereicht wird.)
	for (int i=0;i<VeryLongSize;i++)
	{
		temp=Zahl[i]+Wert2%256+uebertrag;
		Wert2=Wert2/256;
		ergebnis.Zahl[i]=(unsigned char)(temp%256);
		uebertrag=temp/256;
	}
	
	return ergebnis;
}

//berlagerter Minus-Operator zur bildung der Differenz von VeryLong-Zahlen
VeryLong VeryLong::operator - (VeryLong Wert2)
{
	//Variablendeklaration
	VeryLong ergebnis;
	int temp;
	int untertrag=0;

	//Einzelne Stellen subtrahieren
	for (int i=0;i<VeryLongSize;i++)
	{
		temp=(int)Zahl[i]-(int)Wert2.Zahl[i]-untertrag;
		if (temp<0)
		{
			untertrag=1;
			temp+=256;
		}
		else
			untertrag=0;
		ergebnis.Zahl[i]=(unsigned char)temp;
	}

	return ergebnis;
}

//berlagerter Multiplikations-Operator fr VeryLong
VeryLong VeryLong::operator * (VeryLong Wert2)
{
	//Variablendeklaration
	VeryLong ergebnis;
	int		 temp;
	int		 k;

	//Jeden Teil eines Faktors und...
	for (int i=0;i<VeryLongSize;i++)
	{
		//Jeden Teil des anderen Faktors durchlaufen
		for (int j=0;j<VeryLongSize-i;j++)
		{
			temp=Zahl[j]*Wert2.Zahl[i];
			k=0;
			//Ergebnis auf die Stellen verteilen
			//(Bis kein bertrag mehr da ist)
			while (temp>0 && i+j+k<VeryLongSize)
			{
				temp+=ergebnis.Zahl[i+j+k];
				ergebnis.Zahl[i+j+k]=(unsigned char)(temp%256);
				temp/=256;
				k++;
			}
		}
	}
	
	return ergebnis;
}

//berlagerter Multiplikations-Operator fr Typ INT
VeryLong VeryLong::operator * (int Wert2)
{
	//Variablendeklaration
	VeryLong temp;
	VeryLong ergebnis;

	//Lsung ber andere Funktion finden
	temp=Wert2;
	ergebnis=(*this)*temp;

	return ergebnis;
}

//berlagerter Divisions-Operator
VeryLong VeryLong::operator / (VeryLong Wert2)
{
	//Variablendeklaration
	VeryLong ergebnis;
	VeryLong rest;
	VeryLong subtraktor;
	int		 quotientlen=VeryLongSize;
	int		 wertlen=VeryLongSize;
	int		 i;
	rest=(*this);

	//Berechnung der Lnge der Zahlen
	while (Zahl[wertlen-1]==0) wertlen--;
	while (Wert2.Zahl[quotientlen-1]==0) quotientlen--;
	i=wertlen-quotientlen;

	//wenn der Wert kleiner als der Teiler ist, dann ist das Ergebnis 0
	if (i<0) return ergebnis;

	//(i gibt die differenz in der Lnge der Zahlen an und mu fr
	// jede Verschiebung einmal durchlaufen werden)
	while (i>=0)
	{
		//Subtraktor neu aus Teiler durch Stellenverschiebung erstellen
		for (int j=0;j<quotientlen;j++)
			subtraktor.Zahl[j+i]=Wert2.Zahl[j];
		subtraktor.Zahl[quotientlen+i]=0;

		//Subtraktor vom rest so lange abziehen, bis er kleiner ist
		// (Schlechte, aber einfache lsung, deswegen SEHR langsam!)
		while (subtraktor<=rest)
		{
			rest=rest-subtraktor;
			ergebnis.Zahl[i]=(unsigned char)(ergebnis.Zahl[i]+1);
		}

		i--;
	}

	return ergebnis;
}

//berlagerter Modulo-Operator zur ermittlung des Divisionsrestes
// (Sehr hnlich zur division, nur da der REST zurckgegeben wird)
VeryLong VeryLong::operator % (VeryLong Wert2)
{
	//Variablendeklaration
	VeryLong rest;
	VeryLong subtraktor;
	int		 quotientlen=VeryLongSize;
	int		 wertlen=VeryLongSize;
	int		 i;
	//Startwert fr REST zuweisen
	rest=(*this);

	//Berechnung der Lnge der Zahlen
	while (Zahl[wertlen-1]==0) wertlen--;
	while (Wert2.Zahl[quotientlen-1]==0) quotientlen--;
	i=wertlen-quotientlen;

	//wenn der Wert kleiner als der Teiler ist, dann ist das Ergebnis der Ursprung
	if (i<0) return (*this);

	//(i gibt die differenz in der Lnge der Zahlen an und mu fr
	// jede Verschiebung einmal durchlaufen werden)
	while (i>=0)
	{
		//Subtraktor neu aus Teiler durch Stellenverschiebung erstellen
		for (int j=0;j<quotientlen;j++)
			subtraktor.Zahl[j+i]=Wert2.Zahl[j];
		subtraktor.Zahl[quotientlen+i]=0;

		//Subtraktor vom rest so lange abziehen, bis er kleiner ist
		// (Schlechte, aber einfache lsung, deswegen SEHR langsam!)
		while (subtraktor<=rest)
		{
			rest=rest-subtraktor;
		}

		i--;
	}

	return rest;
}

//berlagerter UND-Operator fr Bitweises & ber die gesamte Zahl
VeryLong VeryLong::operator & (VeryLong Wert2)
{
	//Variablendeklaration
	VeryLong ergebnis;

	//jede Stelle im Ergebnis logisch verknpfen
	for (int i=0;i<VeryLongSize;i++)
		ergebnis.Zahl[i]=(unsigned char)(Zahl[i]&Wert2.Zahl[i]);

	return ergebnis;
}

//berlagerter <-Operator zum Vergleich zweier Zahlen
bool VeryLong::operator < (VeryLong Wert2)
{
	//Variablendeklaration
	int pos=VeryLongSize-1;

	//So lange weitervergleichen, solange die vorderen Stellen
	// gleich sind
	while (Zahl[pos]==Wert2.Zahl[pos] && pos>0) pos--;

	return Zahl[pos]<Wert2.Zahl[pos];
}

//berlagerter <-Operator zum Vergleich zweier Zahlen
bool VeryLong::operator > (VeryLong Wert2)
{
	char string[30];
	(*this).GetString(string);
	printf("        Vergleiche %s >",string);
	Wert2.GetString(string);
	printf(" %s",string);
	bool erg;

	//Variablendeklaration
	int pos=VeryLongSize-1;

	//So lange weitervergleichen, solange die vorderen Stellen
	// gleich sind
	while (Zahl[pos]==Wert2.Zahl[pos] && pos>0) pos--;

	erg=Zahl[pos]>Wert2.Zahl[pos];
	printf(" (erg=%s pos=%d)\n",erg?"True":"False",pos);

	return Zahl[pos]>Wert2.Zahl[pos];
}

//berlagerter <=-Operator zum Vergleich zweier Zahlen
bool VeryLong::operator <= (VeryLong Wert2)
{
	//Variablendeklaration
	int pos=VeryLongSize-1;

	//So lange weitervergleichen, solange die vorderen Stellen
	// gleich sind
	while (Zahl[pos]==Wert2.Zahl[pos] && pos>0) pos--;

	return Zahl[pos]<=Wert2.Zahl[pos];
}

//berlagerter <=-Operator zum Vergleich zweier Zahlen
bool VeryLong::operator >= (VeryLong Wert2)
{
	//Variablendeklaration
	int pos=VeryLongSize-1;

	//So lange weitervergleichen, solange die vorderen Stellen
	// gleich sind
	while (Zahl[pos]==Wert2.Zahl[pos] && pos>0) pos--;

	return Zahl[pos]>=Wert2.Zahl[pos];
}

//berlagerter Vergleichs-Operator
bool VeryLong::operator == (VeryLong Wert2)
{
	//Jede Stelle berprfen, falls eine Stelle ungleich ist,
	// sind die Zahlen ungleich
	for (int i=0;i<VeryLongSize;i++)
		if (Zahl[i]!=Wert2.Zahl[i])
			return false;
	return true;
}

//berlagerter Ungleich-Operator
bool VeryLong::operator != (VeryLong Wert2)
{
	//Jede Stelle berprfen, falls eine Stelle ungleich ist,
	// sind die Zahlen ungleich
	for (int i=0;i<VeryLongSize;i++)
		if (Zahl[i]!=Wert2.Zahl[i])
			return true;
	return false;
}

//berlagerter Zuweisungs-Operator, um eine INT-Zahl 
// zu VeryLong zu konvertieren
VeryLong::operator = (int Wert)
{
	//Alle Stellen ablaufen, damit altes sicher gelscht ist.
	for (int i=0;i<VeryLongSize;i++)
	{
		Zahl[i]=(unsigned char)(Wert%256);
		Wert=Wert/256;
	}
}

//berlagerter Zuweisungs-Operator, um VeryLong-Zahlen zu kopieren
VeryLong::operator = (VeryLong Wert)
{
	//Jede Stelle kopieren
	for (int i=0;i<VeryLongSize;i++)
		Zahl[i]=Wert.Zahl[i];
}

//Cast-Operator, um VeryLong in INT zu konvertieren
// (Falls die Zahl zu gro ist, gehen die vorderen Stellen verloren)
// (Ergebnis=Zahl mod 2^31)
VeryLong::operator int()
{
	//Stellen werden einzeln mit der Zweierpotenz multipliziert
	return Zahl[0]+Zahl[1]*256+Zahl[2]*65536+Zahl[3]*16777216;
}

//Den Wert einer VeryLong-Zahl in einen HEX-String kopieren
void VeryLong::GetString(char *output)
{
	//Variablendeklarationen
	int len=VeryLongSize-1;
	
	//Anfang der Zahl finden, um lnge des Strings festzulegen
	while (Zahl[len]==0 && len>0) len--;

	//Stellen einzeln als Hex ausgeben
	for (int i=0;i<=len;i++)
	{
		//Oberes Halbbyte
		if (Zahl[i]/16<=9)
			output[(len-i)*2]=(unsigned char)('0'+Zahl[i]/16);
		else
			output[(len-i)*2]=(unsigned char)('A'+Zahl[i]/16-10);

		//Unteres Halbbyte
		if (Zahl[i]%16<=9)
			output[(len-i)*2+1]=(unsigned char)('0'+Zahl[i]%16);
		else
			output[(len-i)*2+1]=(unsigned char)('A'+Zahl[i]%16-10);
	}

	//String mit '\0' abschlieen
	output[2+len*2]='\0';
}

//Den Wert einer VeryLong-Zahl aus einen HEX-String kopieren
void VeryLong::SetString(const char *input)
{
	//Variablendeklarationen
	int inputlen=strlen(input)/2;

	//Hex-Buchstabenprchen interpretieren
	for (int i=0;i<inputlen;i++)
	{
		//Unteres Halbbyte
		switch (input[(inputlen-i)*2-1])
		{
		case '0': Zahl[i]=0;  break;
		case '1': Zahl[i]=1;  break;
		case '2': Zahl[i]=2;  break;
		case '3': Zahl[i]=3;  break;
		case '4': Zahl[i]=4;  break;
		case '5': Zahl[i]=5;  break;
		case '6': Zahl[i]=6;  break;
		case '7': Zahl[i]=7;  break;
		case '8': Zahl[i]=8;  break;
		case '9': Zahl[i]=9;  break;
		case 'A': Zahl[i]=10; break;
		case 'B': Zahl[i]=11; break;
		case 'C': Zahl[i]=12; break;
		case 'D': Zahl[i]=13; break;
		case 'E': Zahl[i]=14; break;
		case 'F': Zahl[i]=15; break;
		}

		//Oberes Halbbyte
		switch (input[(inputlen-i)*2-2])
		{
		case '0': break;
		case '1': Zahl[i]+=16;  break;
		case '2': Zahl[i]+=32;  break;
		case '3': Zahl[i]+=48;  break;
		case '4': Zahl[i]+=64;  break;
		case '5': Zahl[i]+=80;  break;
		case '6': Zahl[i]+=96;  break;
		case '7': Zahl[i]+=112; break;
		case '8': Zahl[i]+=128; break;
		case '9': Zahl[i]+=144; break;
		case 'A': Zahl[i]+=160; break;
		case 'B': Zahl[i]+=176; break;
		case 'C': Zahl[i]+=192; break;
		case 'D': Zahl[i]+=208; break;
		case 'E': Zahl[i]+=224; break;
		case 'F': Zahl[i]+=240; break;
		}
	}

	//Rest der Stellen mit Nullen leeren
	for (i=inputlen;i<VeryLongSize;i++)
		Zahl[i]=0;
}

//Die Stellen einer VeryLong-Zahl binr in einen String kopieren
// LEN gibt die Stellenzahl an.
void VeryLong::GetBin(char *output, int Len)
{
	//Die letzten x Stellen in die ersten x Positionen kopieren
	for (int i=0;i<Len;i++)
		output[i]=Zahl[Len-1-i];

	//String abschlieen
	output[Len]='\0';
}

//Die Stellen einer VeryLong-Zahl binr aus einen String kopieren
// LEN gibt die Stellenzahl an.
void VeryLong::SetBin(const char *input, int Len)
{
	//Die ersten x Pooitionen in die letzten x Stellen kopieren
	for (int i=0;i<Len;i++)
		Zahl[Len-1-i]=input[i];

	//Restliche Stellen initialisieren
	for (i=Len;i<VeryLongSize;i++)
		Zahl[i]=0;
}

//Gibt die Stellenzahl zurck
// (Verwendet, um die Blockgre fr die chiffrierung zu finden)
int VeryLong::Len()
{
	//Variablendeklarationen
	int l=VeryLongSize-1;

	//Suchen nach einer Stelle, die nicht NULL ist
	while (Zahl[l]==0 && l>=0) l--;

	return l+1;
}

//Externer Einstiegspunkt fr den Aufruf einer
// modularen Exponentiation
// Ergebnis in der Form: Ergebnis=Basisvariable^Potenz mod Modulo
VeryLong VeryLong::ModExp(VeryLong Potenz, VeryLong Modulo)
{
    //Standardwert fr Modulo setzen
    VeryLong ModuloStand;
	ModuloStand = (*this)%Modulo;

	//Potenzstand anlegen
	VeryLong PotenzStand;
	PotenzStand=1;

	//Interne, rekursive Funktion aufrufen
	return ModExpIntern(Potenz, Modulo, ModuloStand, PotenzStand);
}

//Interner Teil der modularen Exponentiaton
// (Ruft sich rekursiv selbst auf)
VeryLong VeryLong::ModExpIntern(VeryLong Potenz, 
                                VeryLong Modulo, 
                                VeryLong ModuloStand,
								VeryLong PotenzStand)
{
	char string[30];
	(*this).GetString(string);
	printf("ModExpIntern aufgefufen mit %s ^ ",string);
	Potenz.GetString(string);
	printf("%s mod ",string);
	Modulo.GetString(string);
	printf("%s (modStand=",string);
	ModuloStand.GetString(string);
	printf("%s PotStand=",string);
	PotenzStand.GetString(string);
	printf("%s)\n",string);

	//Variablendeklaration
	VeryLong PotenzNeu;
	VeryLong ModuloStandNeu;

    // Auf Abbruchkriterium prfen
    if (Potenz>0)
    {
        // Neuen ModuloStand fr nchste Iterationsstufe berechnen
        // Quadrieren des Modulostandes, fr nchste Zweierpotenzsprung
        ModuloStandNeu = ((ModuloStand % Modulo) * (ModuloStand % Modulo)) % Modulo;

        // Prfen, ob diese Potenz fr den aktuellen Punkt 
        //     im 2er Verkor relevant ist
		VeryLong Vergleich;

		Vergleich=Potenz&PotenzStand;
		Vergleich.GetString(string);
		printf("    Potenz&PotenzStand=%s\n",string);

		Vergleich=0;

        if ((Potenz & PotenzStand)>Vergleich)
        {
            // Rest-Potenz berechnen
            PotenzNeu = Potenz - (Potenz & PotenzStand);

            VeryLong A = ModuloStand;
            VeryLong B = ModExpIntern(PotenzNeu, 
                                      Modulo, 
                                      ModuloStandNeu,
									  PotenzStand*2);

			Vergleich=((A % Modulo) * (B % Modulo)) % Modulo;
			Vergleich.GetString(string);
			printf("  1 Gebe %s zurck",string);
			A.GetString(string);
			printf("  (aus A=%s und B=",string);
			B.GetString(string);
			printf("%s)\n",string);

            return ((A % Modulo) * (B % Modulo)) % Modulo;
        }
        // Ansonten an die nchste Rekursionsstufe durchreichen
        else
        {
            Vergleich=ModExpIntern(Potenz, 
                                   Modulo, 
                                   ModuloStandNeu,
							       PotenzStand*2);

			Vergleich.GetString(string);
			printf("  2 Gebe %s zurck\n",string);

			return Vergleich;
        }
    }
	
	//Ende der Rekursion
	VeryLong temp;
	temp=1;

	printf("  3 Gebe 1 zurck\n");    
	
	return temp;
}

VeryLong::VeryLong()
{
	for (int i=0;i<VeryLongSize;i++)
		Zahl[i]=0;
}

VeryLong::~VeryLong()
{
}